<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="650px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
<el-form ref="formRef" :model="formData" label-width="120px" :rules="formRules">
<el-form-item label="土地ID" prop="id">
    <el-input v-model="formData.id" disabled clearable placeholder="请输入土地ID" />
</el-form-item>
<el-form-item label="土地名称" prop="title">
                    <el-input
                        v-model="formData.title"
                        disabled
                        clearable
                        placeholder="请输入土地名称"
                    />
</el-form-item>
<el-form-item label="绑定产品" prop="product_id">
      <el-select
        v-model="formData.product_id"
        remote
        filterable
        placeholder="请输入产品信息"
        :remote-method="queryProduct"
        :loading="loading"
      >
      <el-option
        v-for="(item, index) in optionsData.product"
        :key="index"
        :label="item.productinfo"
        :value="item.id"
    />
      </el-select>
</el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="landEdit">
import { useDictOptions } from '@/hooks/useDictOptions'
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiLandBind, apiProductLists } from '@/api/land'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return (mode.value = '绑定产品')
})

// 表单数据
const formData = reactive({
    id: '',
    title: '',
    product_id: ''
})

// 表单验证
const formRules = reactive<any>({
    product_id: [{
        required: true,
        message: '请选择绑定产品',
        trigger: ['blur']
    }],
})

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const { optionsData } = useDictOptions<{
    product: any[]
}>({
    product: {
        api: apiProductLists
    }
})

const loading = ref(false)

const queryProduct = async (query: string) => {
    loading.value = true
    const productList = await apiProductLists({
        name: query ?? ''
    })
    optionsData.product = productList
    loading.value = false
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData }
    await apiLandBind(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}

const setProduct = async (data: Record<any, any>) => {
    console.log(data)
}

defineExpose({
    open,
    setFormData,
    setProduct
})
</script>
